VERSION 4.00
Begin VB.Form AboutBox 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FFFF00&
   BorderStyle     =   3  'Fixed Double
   Caption         =   "Speed"
   ClientHeight    =   2112
   ClientLeft      =   2112
   ClientTop       =   3264
   ClientWidth     =   4452
   BeginProperty Font 
      name            =   "System"
      charset         =   1
      weight          =   700
      size            =   9.6
      underline       =   0   'False
      italic          =   0   'False
      strikethrough   =   0   'False
   EndProperty
   Height          =   2784
   Icon            =   "aboutbox.frx":0000
   Left            =   2064
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   176
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   371
   Top             =   2640
   Width           =   4548
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   400
      Left            =   240
      Top             =   1560
   End
   Begin VB.CommandButton BTN_OK 
      Caption         =   "OK"
      Height          =   360
      Left            =   1800
      TabIndex        =   0
      Top             =   1680
      Width           =   1080
   End
   Begin VB.PictureBox Picture1 
      BackColor       =   &H00808000&
      Enabled         =   0   'False
      Height          =   1260
      Left            =   840
      ScaleHeight     =   1236
      ScaleWidth      =   2988
      TabIndex        =   1
      Top             =   240
      Width           =   3012
      Begin VB.Label Label4 
         Alignment       =   2  'Center
         BackColor       =   &H00808000&
         Caption         =   "Niranjan Balachandra"
         Height          =   240
         Left            =   120
         TabIndex        =   4
         Top             =   840
         Width           =   2772
      End
      Begin VB.Label Label3 
         Alignment       =   2  'Center
         BackColor       =   &H00808000&
         Caption         =   "Programmed By:"
         Height          =   240
         Left            =   120
         TabIndex        =   3
         Top             =   480
         Width           =   2772
      End
      Begin VB.Label Label2 
         Alignment       =   2  'Center
         BackColor       =   &H00808000&
         Caption         =   "Speed A Card Game"
         Height          =   240
         Left            =   120
         TabIndex        =   2
         Top             =   120
         Width           =   2772
      End
   End
   Begin VB.Menu File 
      Caption         =   "File"
      Begin VB.Menu NewGame 
         Caption         =   "New Game"
         Shortcut        =   {F2}
      End
      Begin VB.Menu Quit 
         Caption         =   "Quit"
         Shortcut        =   {F5}
      End
   End
   Begin VB.Menu Options 
      Caption         =   "Options"
      Begin VB.Menu CCDesign 
         Caption         =   "Change Deck Design"
         Shortcut        =   {F4}
      End
      Begin VB.Menu LevelOfPlay 
         Caption         =   "Level Of Play"
         Begin VB.Menu Easy 
            Caption         =   "Easy"
         End
         Begin VB.Menu Medium 
            Caption         =   "Medium"
            Checked         =   -1  'True
            Enabled         =   0   'False
         End
         Begin VB.Menu Hard 
            Caption         =   "Hard"
         End
      End
      Begin VB.Menu PauseGame 
         Caption         =   "Pause Game"
         Shortcut        =   {F3}
      End
   End
   Begin VB.Menu Help 
      Caption         =   "Help"
      Begin VB.Menu HowToPlaySpeed 
         Caption         =   "How To Play Speed"
         Shortcut        =   {F1}
      End
   End
End
Attribute VB_Name = "AboutBox"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Dim Deck(52) As Integer
Dim xloc As Integer, yloc As Integer
Dim leftCard As Integer, rightCard As Integer
Dim Card1 As Integer, Card2 As Integer
Dim NumComCards As Integer, NumHumCards As Integer

Private Sub BTN_OK_Click()
    
    Dim x As Integer, y As Integer
        
    Rem Initize Settings.
    NumComCards = 0
    NumHumCards = 0
    Timer1.Enabled = True
    Refresh
    AboutBox.WindowState = 2
    SuffleCards
    SetDefaultValues
    Picture1.Visible = False
    Label2.Visible = False
    Label3.Visible = False
    Label4.Visible = False
    BTN_OK.Visible = False
            
    Rem Deal the Cards.
    y = 20
    For x = 1 To 10
        SetCardStatus Deck(x), False
        SetCardDisabled Deck(x), True
        DealCard AboutBox.hwnd, Deck(x), y, 20
        y = y + 75
    Next x
    
    y = 20
    For x = 11 To 20
        SetCardStatus Deck(x), False
        SetCardDisabled Deck(x), True
        DealCard AboutBox.hwnd, Deck(x), y, 120
        y = y + 75
    Next x
  
    For x = 21 To 25
        SetCardStatus Deck(x), False
        SetCardDisabled Deck(x), False
        DealCard AboutBox.hwnd, Deck(x), 200, 235
    Next x
    
    leftCard = 25
    
    SetCardStatus Deck(26), False
    SetCardDisabled Deck(26), True
    SetCardStatus Deck(27), False
    SetCardDisabled Deck(27), True
    DealCard AboutBox.hwnd, Deck(26), 300, 235
    DealCard AboutBox.hwnd, Deck(27), 400, 235
    
    For x = 28 To 32
        SetCardStatus Deck(x), False
        SetCardDisabled Deck(x), False
        DealCard AboutBox.hwnd, Deck(x), 500, 235
    Next x
    
    rightCard = 32
    
    y = 20
    For x = 33 To 42
        DealCard AboutBox.hwnd, Deck(x), y, 350
        y = y + 75
    Next x
    
    y = 20
    For x = 43 To 52
        DealCard AboutBox.hwnd, Deck(x), y, 450
        y = y + 75
    Next x
    
End Sub

Private Sub BTN_OK_GotFocus()
    Dim i As Integer
    
    ' Make the labels slide into the picture box.  Call
    ' the WaitForEventsToFinish procedure to the labels to repaint.
    While Label2.Left <= 120
        Label2.Left = Label2.Left + 50
    Wend

    While Label3.Left > 120
        Label3.Left = Label3.Left - 50
    Wend

    While Label4.Left <= 120
        Label4.Left = Label4.Left + 50
    Wend
End Sub

Private Sub CCDesign_Click()
    Static Back As Integer
    Back = Back + 1
    If Back <= 109 And Back >= 105 Then
        Back = 105
    End If
    SetCurrentBack (Back)
    MsgBox "Deck Back has been changed Sucessfully. Inorder to change the deck you must play a New Game.", , "SUCCESS"
End Sub

Private Sub Easy_Click()
    Timer1.Enabled = False
    Timer1.Interval = 600
    Hard.Enabled = True
    Medium.Enabled = True
    Easy.Checked = True
    Medium.Checked = False
    Hard.Checked = False
    Easy.Enabled = False
    Timer1.Enabled = True
End Sub

Private Sub FlipCard()
  
  Timer1.Enabled = False
  
  If GetCardStatus(Deck(26)) = False Then
    RemoveCard AboutBox.hwnd, Deck(26)
    RemoveCard AboutBox.hwnd, Deck(27)
    SetCardStatus Deck(26), True
    SetCardStatus Deck(27), True
    DealCard AboutBox.hwnd, Deck(26), 300, 235
    DealCard AboutBox.hwnd, Deck(27), 400, 235
    Card1 = GetCardValue(Deck(26))
    Card2 = GetCardValue(Deck(27))
  Else
    
    If rightCard >= 28 And leftCard >= 21 Then
        RemoveCard AboutBox.hwnd, Deck(leftCard)
        RemoveCard AboutBox.hwnd, Deck(rightCard)
        SetCardStatus Deck(leftCard), True
        SetCardStatus Deck(rightCard), True
        SetCardDisabled Deck(leftCard), True
        SetCardDisabled Deck(rightCard), True
        DealCard AboutBox.hwnd, Deck(leftCard), 300, 235
        DealCard AboutBox.hwnd, Deck(rightCard), 400, 235
        Card1 = GetCardValue(Deck(leftCard))
        Card2 = GetCardValue(Deck(rightCard))
        leftCard = leftCard - 1
        rightCard = rightCard - 1
    Else
        MsgBox "Cannot Flip more cards. No more Cards to flip.", , "USER ERROR"
    End If
    
  End If
  
  Timer1.Enabled = True
  
End Sub

Function FindCardInDeck(cardInfo)
    Dim count As Integer
    count = leftCard - 1
    Do
        count = count + 1
    Loop Until Deck(count) = cardInfo Or count >= 52
    
    If Deck(count) = cardInfo Then
        FindCardInDeck = count
    Else
        FindCardInDeck = 0
    End If
    
End Function
Private Sub Form_Click()
    
    Timer1.Enabled = False
    AboutBox.Enabled = False
    
    Dim CardSelected As Integer, CardLeftRight As Integer
    
    CardSelected = PointInFreeCard(xloc, yloc)
    CardSelected = FindCardInDeck(CardSelected)
    
    If (xloc >= 500 And xloc <= 571 And yloc >= 235 And yloc <= 330) Or (xloc >= 200 And xloc <= 271 And yloc >= 235 And yloc <= 330) Then
        CardSelected = 0
        FlipCard
    End If
    
    If GetCardStatus(Deck(26)) And CardSelected <> 0 Then
        CardLeftRight = CardRuleApply(GetCardValue(Deck(CardSelected)))
        If CardLeftRight <> 0 Then
            If CardLeftRight = 1 Then
                RemoveCard AboutBox.hwnd, Deck(CardSelected)
                DealCard AboutBox.hwnd, Deck(CardSelected), 300, 235
                SetCardDisabled Deck(CardSelected), True
                Card1 = GetCardValue(Deck(CardSelected))
            Else
                RemoveCard AboutBox.hwnd, Deck(CardSelected)
                DealCard AboutBox.hwnd, Deck(CardSelected), 400, 235
                SetCardDisabled Deck(CardSelected), True
                Card2 = GetCardValue(Deck(CardSelected))
            End If
            NumHumCards = NumHumCards + 1
        End If
    Else
       If CardSelected <> 0 Then
            MsgBox "Click on left or right pile to flip cards before starting.", , "USER ERROR"
       End If
    End If
    
    Timer1.Enabled = True
    AboutBox.Enabled = True
    
End Sub

Function CardRuleApply(CardValue As Integer) As Integer
    Rem the function return 1 when it is (true and left)and 2 if it is (true and right) and 0 if it is false.
    
    If (Abs(Card1 - CardValue) = 1) Or (Card1 = 13 And CardValue = 1) Or (Card1 = 1 And CardValue = 13) Then
            CardRuleApply = 1
    Else
        If (Abs(Card2 - CardValue) = 1) Or (Card2 = 13 And CardValue = 1) Or (Card2 = 1 And CardValue = 13) Then
            CardRuleApply = 2
        Else
            CardRuleApply = 0
        End If
    End If
        
End Function

Private Sub Form_DblClick()
    MsgBox "Single Click is enough to select the card", , "USER ERROR"
End Sub
Private Sub Form_Load()
    Rem This is to make sure that the dll is loaded.
    Dim nReturn As Integer
    
    AboutBox.ScaleMode = 3
    AboutBox.ScaleTop = 0
    AboutBox.ScaleLeft = 0
    
    nReturn = InitializeDeck(AboutBox.hwnd)
    If nReturn = 0 Then
      MsgBox "Problem Loading Qcard32.dll", , "PROGRAM ERROR"
      End
    End If
    
    ' Force the labels to be displayed outside the
    ' picture box.
    Label2.Left = -3500
    Label3.Left = 5000
    Label4.Left = -3500
    
End Sub

Private Sub SuffleCards()
    
    Dim i As Integer, temp As Integer
    
    Randomize
    
    For i = 1 To 52
        Deck(i) = i
    Next i
    
    For j = 1 To 52
        i = (Int(Rnd * 52) + 1)
        temp = Deck(i)
        Deck(i) = Deck(j)
        Deck(j) = temp
    Next j
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    xloc = x
    yloc = y
End Sub

Private Sub Form_GotFocus()
    
    Timer1.Enabled = False
    
    Refresh
    
    Dim x As Integer
    
    For x = 1 To 52
        DealCard AboutBox.hwnd, Deck(x), GetCardX(Deck(x)), GetCardY(Deck(x))
    Next x
    
    Timer1.Enabled = True
    
End Sub

Private Sub Hard_Click()
    Timer1.Enabled = False
    Timer1.Interval = 200
    Hard.Enabled = False
    Medium.Enabled = True
    Hard.Checked = True
    Easy.Enabled = True
    Medium.Checked = False
    Easy.Checked = False
    Timer1.Enabled = True
End Sub

Private Sub HowToPlaySpeed_Click()
   Timer1.Enabled = False
 ' All the CaptionTextn string variables below are concatenated together with the appropriate
    ' line feed characters to display text in the About dialog box.
    CaptionText1 = "                            Speed is a Fast Card Game. "
    CaptionText2 = "    Inorder to begin you have to flip the left or card pile so that the two cards are facing up."
    CaptionText3 = "    The following is the order in which you must place the cards, the reverse is also accepted."
    CaptionText4 = "                A - 2 - 3 - 4 - 5 - 6 - 7 - 8 - 9 - 10 - Jack - Queen - King"
    CaptionText5 = "    For example, If Two of Spades is placed then you are allowed to choice between an Aces or Three."
    HowToPlay!lblAbout.Caption = CaptionText1 & Chr$(10) & Chr$(10) & CaptionText2 & Chr$(10) & Chr$(10) & CaptionText3 & Chr$(10) & Chr$(10) & CaptionText4 & Chr$(10) & Chr$(10) & CaptionText5 & Chr$(10) & Chr$(10) & "                 HOPE YOU HAVE FUN PLAYING THIS GAME " & Chr$(10) & Chr$(10) & "                                     Niranjan Balachandra"
    ' The Show method with style = 1 displays the dialog as modal. Unloading the
    ' dialog is handled in the cmdOK_Click event procedure.
    HowToPlay.Show 1
End Sub


Private Sub Medium_Click()
    Timer1.Enabled = False
    Timer1.Interval = 400
    Hard.Enabled = True
    Medium.Enabled = False
    Medium.Checked = True
    Easy.Enabled = True
    Easy.Checked = False
    Hard.Checked = False
    Timer1.Enabled = True
End Sub

Private Sub NewGame_Click()
    BTN_OK_Click
End Sub

Private Sub PauseGame_Click()
    If PauseGame.Checked = False Then
      Timer1.Enabled = False
      PauseGame.Checked = True
    Else
      Timer1.Enabled = True
      PauseGame.Checked = False
    End If
End Sub

Private Sub Quit_Click()
    Timer1.Enabled = False
    End
End Sub

Private Sub Timer1_Timer()
 
 Dim CardSelected As Integer, CardLeftRight As Integer
 Static CardNumXY As Integer, x As Integer
 Dim Found
 
 If NumComCards < 20 And NumHumCards < 20 Then
     
        CardNumXY = x
        Found = False
    Do
        x = x + 1
        
        If CardNumXY > 20 Then
            CardNumXY = 0
            x = 0
        End If
        
        If GetCardX(Deck(x)) <> 300 And GetCardX(Deck(x)) <> 400 And GetCardY(Deck(y)) <> 235 Then
          Found = True
        End If
        
    Loop Until Found
   
    CardNumXY = x
   
    If CardNumXY <= 20 Then
    
        CardSelected = Deck(CardNumXY)
        
        If GetCardStatus(Deck(26)) And CardSelected <> 0 Then
            CardLeftRight = CardRuleApply(GetCardValue(CardSelected))
            If CardLeftRight <> 0 Then
                If CardLeftRight = 1 Then
                    RemoveCard AboutBox.hwnd, CardSelected
                    SetCardStatus CardSelected, True
                    DealCard AboutBox.hwnd, CardSelected, 300, 235
                    Card1 = GetCardValue(CardSelected)
                Else
                    RemoveCard AboutBox.hwnd, CardSelected
                    SetCardStatus CardSelected, True
                    DealCard AboutBox.hwnd, CardSelected, 400, 235
                    Card2 = GetCardValue(CardSelected)
                End If
                NumComCards = NumComCards + 1
            End If
        End If
  End If
 End If
    If NumComCards = 20 Then
       response = MsgBox("Computer Wins. Press OK to play again", vbOKCancel, "WINNER")
           If response = vbOK Then
               NewGame_Click
           Else
               Timer1.Enabled = False
               Refresh
           End If
    End If
    
    If NumHumCards = 20 Then
       response = MsgBox("Human Player Wins. Press OK to play to again", vbOKCancel, "WINNER")
       If response = vbOK Then
               NewGame_Click
           Else
               Timer1.Enabled = False
               Refresh
       End If
    End If
    
End Sub
